/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.modules.guosen.bonusscene.controller;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import com.github.xiaoymin.knife4j.annotations.ApiOperationSupport;
import lombok.AllArgsConstructor;
import javax.validation.Valid;

import org.springblade.core.mp.support.Condition;
import org.springblade.core.mp.support.Query;
import org.springblade.core.tool.api.R;
import org.springblade.core.tool.utils.Func;
import org.springblade.core.tool.utils.StringUtil;
import org.springblade.modules.guosen.bonusscene.vo.SimpleBonusSceneVO;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.bind.annotation.RequestParam;
import com.baomidou.mybatisplus.core.metadata.IPage;
import org.springblade.modules.guosen.bonusscene.entity.BonusScene;
import org.springblade.modules.guosen.bonusscene.vo.BonusSceneVO;
import org.springblade.modules.guosen.bonusscene.wrapper.BonusSceneWrapper;
import org.springblade.modules.guosen.bonusscene.service.IBonusSceneService;
import org.springblade.core.boot.ctrl.BladeController;

import java.util.List;
import java.util.stream.Collectors;

/**
 * 分润业务场景 控制器
 *
 * @author BladeX
 * @since 2021-11-13
 */
@RestController
@AllArgsConstructor
@RequestMapping("cyzh-bonus-scene/bonusscene")
@Api(value = "分润业务场景", tags = "分润业务场景接口")
public class BonusSceneController extends BladeController {

	private final IBonusSceneService bonusSceneService;

	/**
	 * 详情
	 */
	@GetMapping("/detail")
	@ApiOperationSupport(order = 1)
	@ApiOperation(value = "详情", notes = "传入bonusScene")
	public R<BonusSceneVO> detail(BonusScene bonusScene) {
		BonusScene detail = bonusSceneService.getOne(Condition.getQueryWrapper(bonusScene));
		return R.data(BonusSceneWrapper.build().entityVO(detail));
	}

	/**
	 * 分页 分润业务场景
	 */
	@GetMapping("/list")
	@ApiOperationSupport(order = 2)
	@ApiOperation(value = "分页", notes = "传入bonusScene")
	public R<IPage<BonusSceneVO>> list(BonusScene bonusScene, Query query) {
		IPage<BonusScene> pages = bonusSceneService.page(Condition.getPage(query), Condition.getQueryWrapper(bonusScene));
		return R.data(BonusSceneWrapper.build().pageVO(pages));
	}


	/**
	 * 自定义分页 分润业务场景
	 */
	@GetMapping("/page")
	@ApiOperationSupport(order = 3)
	@ApiOperation(value = "分页", notes = "传入bonusScene")
	public R<IPage<BonusSceneVO>> page(BonusSceneVO bonusScene, Query query) {
		IPage<BonusSceneVO> pages = bonusSceneService.selectBonusScenePage(Condition.getPage(query), bonusScene);
		return R.data(pages);
	}

	/**
	 * 新增 分润业务场景
	 */
	@PostMapping("/save")
	@ApiOperationSupport(order = 4)
	@ApiOperation(value = "新增", notes = "传入bonusScene")
	public R save(@Valid @RequestBody BonusScene bonusScene) {
		return R.status(bonusSceneService.save(bonusScene));
	}

	/**
	 * 修改 分润业务场景
	 */
	@PostMapping("/update")
	@ApiOperationSupport(order = 5)
	@ApiOperation(value = "修改", notes = "传入bonusScene")
	public R update(@Valid @RequestBody BonusScene bonusScene) {
		return R.status(bonusSceneService.updateById(bonusScene));
	}

	/**
	 * 新增或修改 分润业务场景
	 */
	@PostMapping("/submit")
	@ApiOperationSupport(order = 6)
	@ApiOperation(value = "新增或修改", notes = "传入bonusScene")
	public R submit(@Valid @RequestBody BonusScene bonusScene) {
		return R.status(bonusSceneService.saveOrUpdate(bonusScene));
	}

	
	/**
	 * 删除 分润业务场景
	 */
	@PostMapping("/remove")
	@ApiOperationSupport(order = 7)
	@ApiOperation(value = "逻辑删除", notes = "传入ids")
	public R remove(@ApiParam(value = "主键集合", required = true) @RequestParam String ids) {
		return R.status(bonusSceneService.deleteLogic(Func.toLongList(ids)));
	}

	/**
	 * 根据条件下拉获取分润业务场景list
	 * @param bonusScene
	 * @return
	 */
	@GetMapping(value = "/listBonusScene")
	@ApiOperationSupport(order = 8)
	public R<List<SimpleBonusSceneVO>> listBonusScene(BonusScene bonusScene){
		LambdaQueryWrapper<BonusScene> lambdaQueryWrapper = new LambdaQueryWrapper<>();
		if(StringUtil.isNotBlank(bonusScene.getSceneName())){
			lambdaQueryWrapper.like(BonusScene::getSceneName, bonusScene.getSceneName());
		}
		List<BonusScene> list = this.bonusSceneService.list(lambdaQueryWrapper);
		List<SimpleBonusSceneVO> voList = list.stream()
						.map(item -> {
							SimpleBonusSceneVO vo = new SimpleBonusSceneVO();
							vo.setId(item.getId());
							vo.setName(item.getSceneName());
							return vo;
						}).collect(Collectors.toList());
		return R.data(voList);
	}
	
}
